Index: trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeTransfer.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeTransfer.asm	(revision 150)
+++ trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeTransfer.asm	(revision 150)
@@ -0,0 +1,366 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	IDE Device transfer functions.
+
+; Structure containing variables for PIO transfer functions.
+; This struct must not be larger than IDEPACK without INTPACK.
+struc PIOVARS
+	.wBlocksLeft			resb	2
+	.wBlockSize				resb	2	; Block size in WORDs (256...32768)
+	.wDataPort				resb	2
+	.bSectorsInLastBlock:	resb	1
+							resb	1	; Offset 7 = IDEPACK.bDeviceControl
+	.fnXfer					resb	2	; Offset to transfer function
+endstruc
+
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; IdeTransfer_StartWithCommandInAL
+;	Parameters:
+;		AL:		IDE command that was used to start the transfer
+;		ES:SI:	Ptr to destination buffer or source data
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEPACK
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BX, CX, DX, SI, ES
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+IdeTransfer_StartWithCommandInAL:
+	mov		ah, [bp+IDEPACK.bSectorCountHighExt]
+
+	; Are we reading or writing
+	cmp		al, COMMAND_WRITE_MULTIPLE
+	je		SHORT .PrepareToWriteDataFromESSI
+	cmp		al, COMMAND_WRITE_MULTIPLE_EXT
+	je		SHORT .PrepareToWriteDataFromESSI
+	cmp		al, COMMAND_WRITE_SECTORS
+	je		SHORT .PrepareToWriteDataFromESSI
+	cmp		al, COMMAND_WRITE_SECTORS_EXT
+	je		SHORT .PrepareToWriteDataFromESSI
+
+	; Prepare to read data to ESSI
+	mov		bx, g_rgfnPioRead
+	mov		al, [bp+IDEPACK.bSectorCount]
+	call	InitializePiovarsInSSBPwithSectorCountInAX
+	xchg	si, di
+	call	Registers_NormalizeESDI
+	jmp		SHORT ReadFromDrive
+
+ALIGN JUMP_ALIGN
+.PrepareToWriteDataFromESSI:
+	mov		bx, g_rgfnPioWrite
+	mov		al, [bp+IDEPACK.bSectorCount]
+	call	InitializePiovarsInSSBPwithSectorCountInAX
+	call	Registers_NormalizeESSI
+	; Fall to WriteToDrive
+
+
+;--------------------------------------------------------------------
+; WriteToDrive
+;	Parameters:
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		ES:SI:	Normalized ptr to buffer containing data
+;		SS:BP:	Ptr to PIOVARS
+;	Returns:
+;		AH:		BIOS Error code
+;		CF:		0 if transfer succesfull
+;				1 if any error
+;	Corrupts registers:
+;		AL, BX, CX, DX, SI, ES
+;--------------------------------------------------------------------
+WriteToDrive:
+	; Always poll when writing first block (IRQs are generated for following blocks)
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_DRQ, FLG_STATUS_DRQ)
+	call	IdeWait_PollStatusFlagInBLwithTimeoutInBH
+	jc		SHORT .ReturnWithTransferErrorInAH
+ALIGN JUMP_ALIGN
+.WriteNextBlock:
+	mov		dx, [bp+PIOVARS.wDataPort]
+	dec		WORD [bp+PIOVARS.wBlocksLeft]		; Transferring last (possibly partial) block?
+	jz		SHORT .XferLastBlock				;  If so, jump to transfer
+	mov		cx, [bp+PIOVARS.wBlockSize]			; Load block size in WORDs
+	call	[bp+PIOVARS.fnXfer]					; Transfer full block
+
+	; Normalize pointer when necessary
+	mov		ax, si
+	shr		ax, 1								; WORD offset
+	add		ax, [bp+PIOVARS.wBlockSize]
+	jns		SHORT .WaitUntilReadyToTransferNextBlock
+	call	Registers_NormalizeESSI
+
+ALIGN JUMP_ALIGN
+.WaitUntilReadyToTransferNextBlock:
+%ifdef USE_186
+	push	.WriteNextBlock
+	jmp		IdeWait_IRQorDRQ
+%else
+	call	IdeWait_IRQorDRQ
+	jnc		SHORT .WriteNextBlock
+%endif
+.ReturnWithTransferErrorInAH:
+	ret
+
+ALIGN JUMP_ALIGN
+.XferLastBlock:
+	xor		cx, cx
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_DRQ, FLG_STATUS_DRDY)
+	mov		ch, [bp+PIOVARS.bSectorsInLastBlock]; CX = Partial block size in WORDs
+%ifdef USE_186
+	push	IdeWait_IRQorStatusFlagInBLwithTimeoutInBH
+	jmp		[bp+PIOVARS.fnXfer]
+%else
+	call	[bp+PIOVARS.fnXfer]					; Transfer possibly partial block
+	jmp		IdeWait_IRQorStatusFlagInBLwithTimeoutInBH	; Check for errors
+%endif
+
+
+;--------------------------------------------------------------------
+; ReadFromDrive
+;	Parameters:
+;		ES:DI:	Normalized ptr to buffer to recieve data
+;		DS:SI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to PIOVARS
+;	Returns:
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		AH:		BIOS Error code
+;		CF:		0 if transfer succesfull
+;				1 if any error
+;	Corrupts registers:
+;		AL, BX, CX, DX, SI, ES
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+ReadFromDrive:
+	; Wait until drive is ready to transfer
+	xchg	di, si								; DS:DI now points DPT
+	call	IdeWait_IRQorDRQ					; Wait until ready to transfer
+	jc		SHORT WriteToDrive.ReturnWithTransferErrorInAH
+	xchg	si, di								; ES:DI now points buffer
+
+	; Transfer full or last (possible partial) block
+	mov		dx, [bp+PIOVARS.wDataPort]
+	dec		WORD [bp+PIOVARS.wBlocksLeft]
+	jz		SHORT .XferLastBlock
+	mov		cx, [bp+PIOVARS.wBlockSize]			; Load block size in WORDs
+	call	[bp+PIOVARS.fnXfer]					; Transfer full block
+
+	; Normalize pointer when necessary
+	mov		ax, di
+	shr		ax, 1								; WORD offset
+	add		ax, [bp+PIOVARS.wBlockSize]
+	jns		SHORT ReadFromDrive
+	call	Registers_NormalizeESDI
+	jmp		SHORT ReadFromDrive					; Loop while blocks left
+
+ALIGN JUMP_ALIGN
+.XferLastBlock:
+	xor		cx, cx
+	mov		ch, [bp+PIOVARS.bSectorsInLastBlock]; CX = Partial block size in WORDs
+	call	[bp+PIOVARS.fnXfer]					; Transfer possibly partial block
+	mov		di, si								; DS:DI now points DPT
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_DRQ, FLG_STATUS_DRDY)
+	jmp		IdeWait_PollStatusFlagInBLwithTimeoutInBH
+
+
+;--------------------------------------------------------------------
+; InitializePiovarsInSSBPwithSectorCountInAX
+;	Parameters:
+;		AX:		Number of sectors to transfer (0=65536)
+;		BX:		Offset to transfer function lookup table
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to PIOVARS
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, BX, CX, DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+InitializePiovarsInSSBPwithSectorCountInAX:
+	; Store number of blocks to transfer
+	eMOVZX	cx, BYTE [di+DPT_ATA.bSetBlock]		; Block size in sectors
+	xor		dx, dx
+	test	ax, ax
+	eCMOVZ	dl, 1		; DX:AX = Sectors to transfer (1...65536)
+	div		cx			; AX = Full blocks to transfer
+	test	dx, dx
+	mov		dh, cl		; DH = Full block size if no partial blocks to transfer
+	jz		SHORT .NoPartialBlocksToTransfer
+	inc		ax			; Partial block
+	mov		dh, dl		; DH = Size of partial block in sectors
+.NoPartialBlocksToTransfer:
+	mov		[bp+PIOVARS.wBlocksLeft], ax
+	mov		[bp+PIOVARS.bSectorsInLastBlock], dh
+
+	; Store block size in WORDs
+	xchg	ch, cl		; CX = Block size in WORDs
+	mov		[bp+PIOVARS.wBlockSize], cx
+
+	; Get transfer function based on bus type
+	xchg	ax, bx
+	eMOVZX	bx, BYTE [di+DPT.bIdevarsOffset]	; CS:BX now points to IDEVARS
+	mov		dx, [cs:bx+IDEVARS.wPort]			; Load IDE Data port address
+	mov		bl, [cs:bx+IDEVARS.bDevice]			; Load device type to BX
+	add		bx, ax
+	mov		ax, [cs:bx]							; Load offset to transfer function
+	mov		[bp+PIOVARS.wDataPort], dx
+	mov		[bp+PIOVARS.fnXfer], ax
+	ret
+
+
+;--------------------------------------------------------------------
+; DualByteRead		Dual port 8-bit XTIDE PIO read transfer
+; WordRead			Normal 16-bit IDE PIO read transfer
+; DWordRead			VLB/PCI 32-bit IDE PIO read transfer
+; SingleByteRead	Single port 8-bit PIO read transfer
+;	Parameters:
+;		CX:		Block size in WORDs
+;		DX:		IDE Data port address
+;		ES:DI:	Normalized ptr to buffer to recieve data
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, BX, CX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+DualByteRead:
+	times 2	shr	cx, 1			; Loop unrolling
+	mov		bx, 8				; Bit mask for toggling data low/high reg
+ALIGN JUMP_ALIGN
+.InswLoop:
+	eDUAL_BYTE_PORT_INSW
+	eDUAL_BYTE_PORT_INSW
+	eDUAL_BYTE_PORT_INSW
+	eDUAL_BYTE_PORT_INSW
+	loop	.InswLoop
+	ret
+
+ALIGN JUMP_ALIGN
+WordRead:
+	rep
+	db		6Dh			; INSW
+	ret
+
+ALIGN JUMP_ALIGN
+DWordRead:
+	shr		cx, 1		; WORD count to DWORD count
+	rep
+	db		66h			; Override operand size to 32-bit
+	db		6Dh			; INSW/INSD
+	ret
+
+ALIGN JUMP_ALIGN
+SingleByteRead:
+%ifdef USE_186	; INS instruction available
+	shl		cx, 1				; WORD count to BYTE count
+	rep insb
+%else			; If 8088/8086
+	shr		cx, 1				; WORD count to DWORD count
+ALIGN JUMP_ALIGN
+.InsdLoop:
+	in		al, dx
+	stosb						; Store to [ES:DI]
+	in		al, dx
+	stosb
+	in		al, dx
+	stosb
+	in		al, dx
+	stosb
+	loop	.InsdLoop
+%endif
+	ret
+
+
+;--------------------------------------------------------------------
+; DualByteWrite		Dual port 8-bit XTIDE PIO write transfer
+; WordWrite			Normal 16-bit IDE PIO write transfer
+; DWordWrite		VLB/PCI 32-bit IDE PIO write transfer
+; SingleByteWrite	Single port 8-bit PIO write transfer
+;	Parameters:
+;		CX:		Block size in WORDs
+;		DX:		IDE Data port address
+;		ES:SI:	Normalized ptr to buffer containing data
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+DualByteWrite:
+	push	ds
+	push	bx
+	times 2	shr	cx, 1			; Loop unrolling
+	mov		bx, 8				; Bit mask for toggling data low/high reg
+	push	es					; Copy ES...
+	pop		ds					; ...to DS
+ALIGN JUMP_ALIGN
+.OutswLoop:
+	eDUAL_BYTE_PORT_OUTSW
+	eDUAL_BYTE_PORT_OUTSW
+	eDUAL_BYTE_PORT_OUTSW
+	eDUAL_BYTE_PORT_OUTSW
+	loop	.OutswLoop
+	pop		bx
+	pop		ds
+	ret
+
+ALIGN JUMP_ALIGN
+WordWrite:
+	eSEG	es			; Source is ES segment
+	rep
+	db		6Fh			; OUTSW
+	ret
+
+ALIGN JUMP_ALIGN
+DWordWrite:
+	shr		cx, 1		; WORD count to DWORD count
+	eSEG	es			; Source is ES segment
+	rep
+	db		66h			; Override operand size to 32-bit
+	db		6Fh			; OUTSW/OUTSD
+	ret
+
+ALIGN JUMP_ALIGN
+SingleByteWrite:
+%ifdef USE_186	; OUTS instruction available
+	shl		cx, 1				; WORD count to BYTE count
+	eSEG	es					; Source is ES segment
+	rep outsb
+%else			; If 8088/8086
+	shr		cx, 1				; WORD count to DWORD count
+	push	ds					; Store DS
+	push	es					; Copy ES...
+	pop		ds					; ...to DS
+ALIGN JUMP_ALIGN
+.OutsdLoop:
+	lodsb						; Load from [DS:SI] to AL
+	out		dx, al
+	lodsb
+	out		dx, al
+	lodsb
+	out		dx, al
+	lodsb
+	out		dx, al
+	loop	.OutsdLoop
+	pop		ds					; Restore DS
+%endif
+	ret
+
+
+; Lookup tables to get transfer function based on bus type
+ALIGN WORD_ALIGN
+g_rgfnPioRead:
+	dw		DualByteRead		; DEVICE_8BIT_DUAL_PORT_XTIDE
+	dw		NULL				; DEVICE_XTIDE_WITH_REVERSED_A3_AND_A0
+	dw		SingleByteRead		; DEVICE_8BIT_SINGLE_PORT
+	dw		WordRead			; DEVICE_16BIT_ATA
+	dw		DWordRead			; DEVICE_32BIT_ATA
+g_rgfnPioWrite:
+	dw		DualByteWrite		; DEVICE_8BIT_DUAL_PORT_XTIDE
+	dw		NULL				; DEVICE_XTIDE_WITH_REVERSED_A3_AND_A0
+	dw		SingleByteWrite		; DEVICE_8BIT_SINGLE_PORT
+	dw		WordWrite			; DEVICE_16BIT_ATA
+	dw		DWordWrite			; DEVICE_32BIT_ATA
Index: trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeWait.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeWait.asm	(revision 150)
+++ trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeWait.asm	(revision 150)
@@ -0,0 +1,129 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	IDE Device wait functions.
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; IdeWait_IRQorDRQ
+;	Parameters:
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEPACK or PIOVARS
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BX, CX, DX
+;--------------------------------------------------------------------
+IdeWait_IRQorDRQ:
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_DRQ, FLG_STATUS_DRQ)
+	test	BYTE [bp+IDEPACK.bDeviceControl], FLG_DEVCONTROL_nIEN
+	jnz		SHORT IdeWait_PollStatusFlagInBLwithTimeoutInBH	; Interrupt disabled
+	; Fall to IdeWait_IRQorStatusFlagInBLwithTimeoutInBH
+
+
+;--------------------------------------------------------------------
+; IdeWait_IRQorStatusFlagInBLwithTimeoutInBH
+;	Parameters:
+;		BH:		Timeout ticks
+;		BL:		IDE Status Register bit to wait
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BX, CX, DX
+;--------------------------------------------------------------------
+IdeWait_IRQorStatusFlagInBLwithTimeoutInBH:
+	call	IdeIrq_WaitForIRQ
+	; Always fall to IdeWait_PollStatusFlagInBLwithTimeoutInBH for error processing
+
+
+;--------------------------------------------------------------------
+; IdeWait_PollStatusFlagInBLwithTimeoutInBH
+;	Parameters:
+;		BH:		Timeout ticks
+;		BL:		IDE Status Register bit to poll
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BX, CX, DX
+;--------------------------------------------------------------------
+IdeWait_PollStatusFlagInBLwithTimeoutInBH:
+	eMOVZX	cx, bh		; Timeout ticks now in CX
+	mov		ah, bl
+	call	HTimer_InitializeTimeoutWithTicksInCX
+	and		ah, ~FLG_STATUS_BSY
+	jz		SHORT PollBsyOnly
+	; Fall to PollBsyAndFlgInAH
+
+;--------------------------------------------------------------------
+; PollBsyAndFlgInAH
+;	Parameters:
+;		AH:		Status Register Flag to poll (until set) when device not busy
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		AH:		BIOS Error code
+;		CF:		Clear if wait completed successfully (no errors)
+;				Set if any error
+;	Corrupts registers:
+;		AL, BX, CX, DX
+;--------------------------------------------------------------------
+PollBsyAndFlgInAH:
+	call	ReadIdeStatusRegisterToAL			; Discard contents for first read
+ALIGN JUMP_ALIGN
+.PollLoop:
+	call	ReadIdeStatusRegisterToAL
+	test	al, FLG_STATUS_BSY					; Controller busy?
+	jnz		SHORT .UpdateTimeout				;  If so, jump to timeout update
+	test	al, ah								; Test secondary flag
+	jnz		SHORT IdeError_GetBiosErrorCodeToAHfromPolledStatusRegisterInAL
+.UpdateTimeout:
+	call	HTimer_SetCFifTimeout
+	jnc		SHORT .PollLoop						; Loop if time left
+	call	IdeError_GetBiosErrorCodeToAHfromPolledStatusRegisterInAL
+	jc		SHORT .ReturnErrorCodeInAH
+	mov		ah, RET_HD_TIMEOUT					; Expected bit never got set
+	stc
+.ReturnErrorCodeInAH:
+	ret
+
+
+;--------------------------------------------------------------------
+; PollBsyOnly
+;	Parameters:
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		AH:		BIOS Error code
+;		CF:		Clear if wait completed successfully (no errors)
+;				Set if any error
+;	Corrupts registers:
+;		AL, BX, CX, DX
+;--------------------------------------------------------------------
+PollBsyOnly:
+	call	ReadIdeStatusRegisterToAL			; Discard contents for first read
+ALIGN JUMP_ALIGN
+.PollLoop:
+	call	ReadIdeStatusRegisterToAL
+	test	al, FLG_STATUS_BSY					; Controller busy?
+	jz		SHORT IdeError_GetBiosErrorCodeToAHfromPolledStatusRegisterInAL
+	call	HTimer_SetCFifTimeout				; Update timeout counter
+	jnc		SHORT .PollLoop						; Loop if time left (sets CF on timeout)
+	jmp		SHORT IdeError_GetBiosErrorCodeToAHfromPolledStatusRegisterInAL
+
+
+;--------------------------------------------------------------------
+; ReadIdeStatusRegisterToAL
+;	Parameters:
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		AL:		IDE Status Register contents
+;	Corrupts registers:
+;		BX, DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+ReadIdeStatusRegisterToAL:
+	mov		dl, STATUS_REGISTER_in
+	jmp		Device_InputToALfromIdeRegisterInDL
Index: trunk/XTIDE_Universal_BIOS/Src/Device/Idepack.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Device/Idepack.asm	(revision 150)
+++ trunk/XTIDE_Universal_BIOS/Src/Device/Idepack.asm	(revision 150)
@@ -0,0 +1,104 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Functions for managing IDEPACK struct.
+
+SIZE_OF_FAKE_IDEPACK		EQU		(IDEPACK_size - INTPACK_size)
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; Idepack_FakeToSSBP
+;	Parameters:
+;		Nothing
+;	Returns:
+;		SS:BP:	Ptr to IDEPACK
+;	Corrupts registers:
+;		AX
+;--------------------------------------------------------------------
+Idepack_FakeToSSBP:
+	pop		ax
+	sub		sp, BYTE SIZE_OF_FAKE_IDEPACK
+	mov		bp, sp
+	jmp		ax
+
+
+;--------------------------------------------------------------------
+; Idepack_TranslateOldInt13hAddressAndIssueCommandFromAH
+;	Parameters:
+;		AH:		IDE command to issue
+;		AL:		Number of sectors to transfer (1...255, 0=256)
+;		BH:		Timeout ticks
+;		BL:		IDE Status Register flag to wait after command
+;		CH:		Cylinder number, bits 7...0
+;		CL:		Bits 7...6: Cylinder number bits 9 and 8
+;				Bits 5...0:	Starting sector number (1...63)
+;		DH:		Starting head number (0...255)
+;		ES:SI:	Ptr to data buffer
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEPACK
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BX, CX, DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+Idepack_TranslateOldInt13hAddressAndIssueCommandFromAH:
+	mov		[bp+IDEPACK.bSectorCount], al
+	mov		[bp+IDEPACK.bCommand], ah
+	mov		BYTE [bp+IDEPACK.bSectorCountHighExt], 0
+
+	push	bx
+	call	HAddress_OldInt13hAddressToIdeAddress
+	call	AccessDPT_GetDriveSelectByteToAL
+	or		al, bh			; AL now has Drive and Head Select Byte
+	mov		[bp+IDEPACK.bDrvAndHead], al
+	mov		[bp+IDEPACK.bLbaLow], bl
+	mov		[bp+IDEPACK.wLbaMiddleAndHigh], cx
+	pop		bx
+
+	call	AccessDPT_GetDeviceControlByteToAL
+	mov		[bp+IDEPACK.bDeviceControl], al
+	jmp		Device_OutputCommandWithParameters
+
+
+;--------------------------------------------------------------------
+; Idepack_StoreNonExtParametersAndIssueCommandFromAL
+;	Parameters:
+;		BH:		Timeout ticks
+;		BL:		IDE Status Register flag to wait after command
+;		AL:		IDE command to issue
+;		AH:		Parameter to Drive and Head Select Register (Head bits only)
+;		DL:		Parameter to Sector Count Register
+;		DH:		Parameter to LBA Low / Sector Number Register
+;		CL:		Parameter to LBA Middle / Cylinder Low Register
+;		CH:		Parameter to LBA High / Cylinder High Register
+;		SI:		Parameter to Features Register
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEPACK
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BX, CX, DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+Idepack_StoreNonExtParametersAndIssueCommandFromAL:
+	mov		[bp+IDEPACK.bFeatures], si
+	mov		[bp+IDEPACK.bCommand], al
+	mov		[bp+IDEPACK.wSectorCountAndLbaLow], dx
+	mov		[bp+IDEPACK.wLbaMiddleAndHigh], cx
+	mov		BYTE [bp+IDEPACK.bSectorCountHighExt], 0
+
+	; Drive and Head select byte
+	and		ah, MASK_DRVNHEAD_HEAD		; Keep head bits only
+	call	AccessDPT_GetDriveSelectByteToAL
+	or		al, ah
+	mov		[bp+IDEPACK.bDrvAndHead], al
+
+	; Device Control byte with interrupts disabled
+	call	AccessDPT_GetDeviceControlByteToAL
+	or		al, FLG_DEVCONTROL_nIEN		; Disable interrupt
+	mov		[bp+IDEPACK.bDeviceControl], al
+
+	jmp		Device_OutputCommandWithParameters
Index: trunk/XTIDE_Universal_BIOS/Src/Device/Serial/SerialCommand.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Device/Serial/SerialCommand.asm	(revision 150)
+++ trunk/XTIDE_Universal_BIOS/Src/Device/Serial/SerialCommand.asm	(revision 150)
@@ -0,0 +1,41 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Serial Device Command functions.
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; SerialCommand_IdentifyDeviceToBufferInESSIwithDriveSelectByteInBH
+;	Parameters:
+;		BH:		Drive Select byte for Drive and Head Select Register
+;		DS:		Segment to RAMVARS
+;		ES:SI:	Ptr to buffer to receive 512-byte IDE Information
+;		CS:BP:	Ptr to IDEVARS
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BL, CX, DX, SI, DI, ES
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+SerialCommand_IdentifyDeviceToBufferInESSIwithDriveSelectByteInBH:
+
+
+;--------------------------------------------------------------------
+; SerialCommand_OutputWithParameters
+;	Parameters:
+;		BH:		Non-zero if 48-bit addressing used
+;		BL:		IDE Status Register bit to poll after command
+;		ES:SI:	Ptr to buffer (for data transfer commands)
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEREGS_AND_INTPACK
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BX, CX, DX, (ES:SI for data transfer commands)
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+SerialCommand_OutputWithParameters:
+
+
Index: trunk/XTIDE_Universal_BIOS/Src/Device/Serial/SerialDPT.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Device/Serial/SerialDPT.asm	(revision 150)
+++ trunk/XTIDE_Universal_BIOS/Src/Device/Serial/SerialDPT.asm	(revision 150)
@@ -0,0 +1,17 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Sets Serial Device specific parameters to DPT.
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; SerialDPT_Finalize
+;	Parameters:
+;		DS:DI:	Ptr to Disk Parameter Table
+;		ES:SI:	Ptr to 512-byte ATA information read from the drive
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, BX, CX, DX
+;--------------------------------------------------------------------
+SerialDPT_Finalize:
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h.asm	(revision 150)
@@ -22,5 +22,6 @@
 Int13h_DiskFunctionsHandler:
 	sti									; Enable interrupts
-	SAVE_AND_GET_INTPACK_TO_SSBP
+	cld									; String instructions to increment pointers
+	SAVE_AND_GET_INTPACK_WITH_EXTRA_WORDS_TO_SSBP EXTRA_WORDS_TO_RESERVE_FOR_INTPACK
 
 	call	RamVars_GetSegmentToDS
@@ -46,5 +47,5 @@
 ;		DL:		Translated drive number
 ;		DS:		RAMVARS segment
-;		SS:BP:	Ptr to INTPACK
+;		SS:BP:	Ptr to IDEPACK
 ;		BX, DI:	Corrupted on Int13h_DiskFunctionsHandler
 ;		Other:	Function specific INT 13h parameters 
@@ -58,11 +59,11 @@
 Int13h_DirectCallToAnotherBios:
 	call	ExchangeCurrentInt13hHandlerWithOldInt13hHandler
-	mov		bx, [bp+INTPACK.bx]
-	mov		di, [bp+INTPACK.di]
-	mov		ds, [bp+INTPACK.ds]
-	push	WORD [bp+INTPACK.flags]
+	mov		bx, [bp+IDEPACK.intpack+INTPACK.bx]
+	mov		di, [bp+IDEPACK.intpack+INTPACK.di]
+	mov		ds, [bp+IDEPACK.intpack+INTPACK.ds]
+	push	WORD [bp+IDEPACK.intpack+INTPACK.flags]
 	popf
 	push	bp
-	mov		bp, [bp+INTPACK.bp]
+	mov		bp, [bp+IDEPACK.intpack+INTPACK.bp]
 	int		BIOS_DISK_INTERRUPT_13h	; Can safely do as much recursion as it wants
 
@@ -70,21 +71,21 @@
 	pop		bp	; Standard INT 13h functions never uses BP as return register
 %ifdef USE_386
-	mov		[bp+INTPACK.gs], gs
-	mov		[bp+INTPACK.fs], fs
+	mov		[bp+IDEPACK.intpack+INTPACK.gs], gs
+	mov		[bp+IDEPACK.intpack+INTPACK.fs], fs
 %endif
-	mov		[bp+INTPACK.es], es
-	mov		[bp+INTPACK.ds], ds
-	mov		[bp+INTPACK.di], di
-	mov		[bp+INTPACK.si], si
-	mov		[bp+INTPACK.bx], bx
-	mov		[bp+INTPACK.dh], dh
-	mov		[bp+INTPACK.cx], cx
-	mov		[bp+INTPACK.ax], ax
+	mov		[bp+IDEPACK.intpack+INTPACK.es], es
+	mov		[bp+IDEPACK.intpack+INTPACK.ds], ds
+	mov		[bp+IDEPACK.intpack+INTPACK.di], di
+	mov		[bp+IDEPACK.intpack+INTPACK.si], si
+	mov		[bp+IDEPACK.intpack+INTPACK.bx], bx
+	mov		[bp+IDEPACK.intpack+INTPACK.dh], dh
+	mov		[bp+IDEPACK.intpack+INTPACK.cx], cx
+	mov		[bp+IDEPACK.intpack+INTPACK.ax], ax
 	pushf
-	pop		WORD [bp+INTPACK.flags]
+	pop		WORD [bp+IDEPACK.intpack+INTPACK.flags]
 	call	RamVars_GetSegmentToDS
 	cmp		dl, [RAMVARS.xlateVars+XLATEVARS.bXlatedDrv]
 	je		SHORT .ExchangeInt13hHandlers
-	mov		[bp+INTPACK.dl], dl		; Something is returned in DL
+	mov		[bp+IDEPACK.intpack+INTPACK.dl], dl		; Something is returned in DL
 ALIGN JUMP_ALIGN
 .ExchangeInt13hHandlers:
@@ -98,5 +99,5 @@
 ;	Parameters:
 ;		AH:		BIOS Error code
-;		SS:BP:	Ptr to INTPACK
+;		SS:BP:	Ptr to IDEPACK
 ;	Returns:
 ;		All registers are loaded from INTPACK
@@ -104,9 +105,9 @@
 ALIGN JUMP_ALIGN
 Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH:
-	call	HError_SetErrorCodeToBdaAndToIntpackInSSBPfromAH
+	call	Int13h_SetErrorCodeToBdaAndToIntpackInSSBPfromAH
 Int13h_ReturnFromHandlerWithoutStoringErrorCode:
-	or		WORD [bp+INTPACK.flags], FLG_FLAGS_IF	; Return with interrupts enabled
+	or		WORD [bp+IDEPACK.intpack+INTPACK.flags], FLG_FLAGS_IF	; Return with interrupts enabled
 	mov		sp, bp									; Now we can exit anytime
-	RESTORE_INTPACK_FROM_SSBP
+	RESTORE_INTPACK_WITH_EXTRA_WORDS_FROM_SSBP EXTRA_WORDS_TO_RESERVE_FOR_INTPACK
 
 
@@ -146,4 +147,5 @@
 	LOAD_BDA_SEGMENT_TO	es, di
 	mov		di, [RAMVARS.fpOldI13h]
+	cli
 	xchg	di, [es:BIOS_DISK_INTERRUPT_13h*4]
 	mov		[RAMVARS.fpOldI13h], di
@@ -152,4 +154,34 @@
 	mov		[RAMVARS.fpOldI13h+2], di
 	pop		es
+	sti
+	ret
+
+
+;--------------------------------------------------------------------
+; Int13h_SetErrorCodeToBdaAndToIntpackInSSBPfromAH
+; Int13h_SetErrorCodeToIntpackInSSBPfromAH
+;	Parameters:
+;		AH:		BIOS error code (00h = no error)
+;		SS:BP:	Ptr to IDEPACK
+;	Returns:
+;		SS:BP:	Ptr to IDEPACK with error condition set
+;	Corrupts registers:
+;		DS, DI
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+Int13h_SetErrorCodeToBdaAndToIntpackInSSBPfromAH:
+	; Store error code to BDA
+	LOAD_BDA_SEGMENT_TO	ds, di
+	mov		[BDA.bHDLastSt], ah
+
+	; Store error code to INTPACK
+Int13h_SetErrorCodeToIntpackInSSBPfromAH:
+	mov		[bp+IDEPACK.intpack+INTPACK.ah], ah
+	test	ah, ah
+	jnz		SHORT .SetCFtoIntpack
+	and		BYTE [bp+IDEPACK.intpack+INTPACK.flags], ~FLG_FLAGS_CF
+	ret
+.SetCFtoIntpack:
+	or		BYTE [bp+IDEPACK.intpack+INTPACK.flags], FLG_FLAGS_CF
 	ret
 
@@ -224,16 +256,20 @@
 ;	dw	Int13h_UnsupportedFunction						; 3Fh, 
 ;	dw	Int13h_UnsupportedFunction						; 40h, 
-;	dw	Int13h_UnsupportedFunction						; 41h, Check if Extensions Present (EBIOS)
-;	dw	Int13h_UnsupportedFunction						; 42h, Extended Read Sectors (EBIOS)
-;	dw	Int13h_UnsupportedFunction						; 43h, Extended Write Sectors (EBIOS)
-;	dw	Int13h_UnsupportedFunction						; 44h, Extended Verify Sectors (EBIOS)
-;	dw	Int13h_UnsupportedFunction						; 45h, Lock and Unlock Drive (EBIOS)
-;	dw	Int13h_UnsupportedFunction						; 46h, Eject Media Request (EBIOS)
-;	dw	Int13h_UnsupportedFunction						; 47h, Extended Seek (EBIOS)
-;	dw	Int13h_UnsupportedFunction						; 48h, Get Extended Drive Parameters (EBIOS)
-;	dw	Int13h_UnsupportedFunction						; 49h, Get Extended Disk Change Status (EBIOS)
+;	dw	Int13h_UnsupportedFunction						; 41h, Check if Extensions Present (EBIOS)*
+;	dw	Int13h_UnsupportedFunction						; 42h, Extended Read Sectors (EBIOS)*
+;	dw	Int13h_UnsupportedFunction						; 43h, Extended Write Sectors (EBIOS)*
+;	dw	Int13h_UnsupportedFunction						; 44h, Extended Verify Sectors (EBIOS)*
+;	dw	Int13h_UnsupportedFunction						; 45h, Lock and Unlock Drive (EBIOS)***
+;	dw	Int13h_UnsupportedFunction						; 46h, Eject Media Request (EBIOS)***
+;	dw	Int13h_UnsupportedFunction						; 47h, Extended Seek (EBIOS)*
+;	dw	Int13h_UnsupportedFunction						; 48h, Get Extended Drive Parameters (EBIOS)*
+;	dw	Int13h_UnsupportedFunction						; 49h, Get Extended Disk Change Status (EBIOS)***
 ;	dw	Int13h_UnsupportedFunction						; 4Ah, Initiate Disk Emulation (Bootable CD-ROM)
 ;	dw	Int13h_UnsupportedFunction						; 4Bh, Terminate Disk Emulation (Bootable CD-ROM)
 ;	dw	Int13h_UnsupportedFunction						; 4Ch, Initiate Disk Emulation and Boot (Bootable CD-ROM)
 ;	dw	Int13h_UnsupportedFunction						; 4Dh, Return Boot Catalog (Bootable CD-ROM)
-;	dw	Int13h_UnsupportedFunction						; 4Eh, Set Hardware Configuration (EBIOS)
+;	dw	Int13h_UnsupportedFunction						; 4Eh, Set Hardware Configuration (EBIOS)**
+;
+;   * = Enhanced Drive Access Support (minimum required EBIOS functions)
+;  ** = Enhanced Disk Drive (EDD) Support
+; *** = Drive Locking and Ejecting Support
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH0h_HReset.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH0h_HReset.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH0h_HReset.asm	(revision 150)
@@ -13,6 +13,6 @@
 ;				If bit 7 is set all hard disks and floppy disks reset.
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
-;		SS:BP:	Ptr to INTPACK
-;	Returns with INTPACK in SS:BP:
+;		SS:BP:	Ptr to IDEPACK
+;	Returns with INTPACK:
 ;		AH:		Int 13h return status (from drive requested in DL)
 ;		CF:		0 if succesfull, 1 if error
@@ -89,12 +89,13 @@
 
 ;--------------------------------------------------------------------
-; ResetHardDisksHandledByOurBIOS
+; AH0h_ResetHardDisksHandledByOurBIOS
 ;	Parameters:
 ;		BL:		Requested drive (DL when entering AH=00h)
 ;		DS:		RAMVARS segment
+;		SS:BP:	Ptr to IDEPACK
 ;	Returns:
 ;		BH:		Error code from requested drive (if available)
 ;	Corrupts registers:
-;		AX, CX, DX, DI
+;		AX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
@@ -103,5 +104,5 @@
 	test	dh, dh
 	jz		SHORT .AllDrivesReset		; Return if no drives
-	mov		dl, [RAMVARS.bFirstDrv]		; Load number of first our drive
+	mov		dl, [RAMVARS.bFirstDrv]		; Load number of our first drive
 	add		dh, dl						; DH = one past last drive to reset
 ALIGN JUMP_ALIGN
@@ -132,13 +133,37 @@
 .BackupErrorCodeFromMasterOrSlaveToBH:
 	call	BackupErrorCodeFromTheRequestedDriveToBH
-	mov		cx, [RAMVARS.wIdeBase]		; Load base port for resetted drive
-
+	call	GetBasePortToCX				; Load base port for resetted drive
+	push	cx
 	inc		dx							; DL to next drive
-	call	FindDPT_ForDriveNumber		; Get DPT to DS:DI, store port to RAMVARS
-	jnc		SHORT .NoMoreDrivesOrNoSlaveDrive
-	cmp		cx, [RAMVARS.wIdeBase]		; Next drive is from same controller?
+	call	GetBasePortToCX
+	pop		di
+	cmp		cx, di						; Next drive is from same controller?
 	je		SHORT BackupErrorCodeFromTheRequestedDriveToBH
 .NoMoreDrivesOrNoSlaveDrive:
 	dec		dx
+	ret
+
+;--------------------------------------------------------------------
+; GetBasePortToCX
+;	Parameters:
+;		DL:		Drive number
+;		DS:		RAMVARS segment
+;	Returns:
+;		CX:		Base port address
+;		CF:		Set if valid drive number
+;				Cleared if invalid drive number
+;	Corrupts registers:
+;		DI
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+GetBasePortToCX:
+	xchg	cx, bx
+	xor		bx, bx
+	call	FindDPT_ForDriveNumber
+	jnc		SHORT .DptNotFound
+	mov		bl, [di+DPT.bIdevarsOffset]
+	mov		bx, [cs:bx+IDEVARS.wPort]
+.DptNotFound:
+	xchg	bx, cx
 	ret
 
